1# Copyright 2018 The Prometheus Authors
2# Licensed under the Apache License, Version 2.0 (the "License");
3# you may not use this file except in compliance with the License.
4# You may obtain a copy of the License at
5#
6# http://www.apache.org/licenses/LICENSE-2.0
7#
8# Unless required by applicable law or agreed to in writing, software
9# distributed under the License is distributed on an "AS IS" BASIS,
10# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
11# See the License for the specific language governing permissions and
12# limitations under the License.
13
14
15# A common Makefile that includes rules to be reused in different prometheus projects.
16# !!! Open PRs only against the prometheus/prometheus/Makefile.common repository!
17
18# Example usage :
19# Create the main Makefile in the root project directory.
20# include Makefile.common
21# customTarget:
22# 	@echo ">> Running customTarget"
23#
24
25# Ensure GOBIN is not set during build so that promu is installed to the correct path
26unexport GOBIN
27
28GO           ?= go
29GOFMT        ?= $(GO)fmt
30FIRST_GOPATH := $(firstword $(subst :, ,$(shell $(GO) env GOPATH)))
31GOOPTS       ?=
32GOHOSTOS     ?= $(shell $(GO) env GOHOSTOS)
33GOHOSTARCH   ?= $(shell $(GO) env GOHOSTARCH)
34
35GO_VERSION        ?= $(shell $(GO) version)
36GO_VERSION_NUMBER ?= $(word 3, $(GO_VERSION))
37PRE_GO_111        ?= $(shell echo $(GO_VERSION_NUMBER) | grep -E 'go1\.(10|[0-9])\.')
38
39GOVENDOR :=
40GO111MODULE :=
41ifeq (, $(PRE_GO_111))
42	ifneq (,$(wildcard go.mod))
43		# Enforce Go modules support just in case the directory is inside GOPATH (and for Travis CI).
44		GO111MODULE := on
45
46		ifneq (,$(wildcard vendor))
47			# Always use the local vendor/ directory to satisfy the dependencies.
48			GOOPTS := $(GOOPTS) -mod=vendor
49		endif
50	endif
51else
52	ifneq (,$(wildcard go.mod))
53		ifneq (,$(wildcard vendor))
54$(warning This repository requires Go >= 1.11 because of Go modules)
55$(warning Some recipes may not work as expected as the current Go runtime is '$(GO_VERSION_NUMBER)')
56		endif
57	else
58		# This repository isn't using Go modules (yet).
59		GOVENDOR := $(FIRST_GOPATH)/bin/govendor
60	endif
61endif
62PROMU        := $(FIRST_GOPATH)/bin/promu
63pkgs          = ./...
64
65ifeq (arm, $(GOHOSTARCH))
66	GOHOSTARM ?= $(shell GOARM= $(GO) env GOARM)
67	GO_BUILD_PLATFORM ?= $(GOHOSTOS)-$(GOHOSTARCH)v$(GOHOSTARM)
68else
69	GO_BUILD_PLATFORM ?= $(GOHOSTOS)-$(GOHOSTARCH)
70endif
71
72PROMU_VERSION ?= 0.5.0
73PROMU_URL     := https://github.com/prometheus/promu/releases/download/v$(PROMU_VERSION)/promu-$(PROMU_VERSION).$(GO_BUILD_PLATFORM).tar.gz
74
75GOLANGCI_LINT :=
76GOLANGCI_LINT_OPTS ?=
77GOLANGCI_LINT_VERSION ?= v1.18.0
78# golangci-lint only supports linux, darwin and windows platforms on i386/amd64.
79# windows isn't included here because of the path separator being different.
80ifeq ($(GOHOSTOS),$(filter $(GOHOSTOS),linux darwin))
81	ifeq ($(GOHOSTARCH),$(filter $(GOHOSTARCH),amd64 i386))
82		GOLANGCI_LINT := $(FIRST_GOPATH)/bin/golangci-lint
83	endif
84endif
85
86PREFIX                  ?= $(shell pwd)
87BIN_DIR                 ?= $(shell pwd)
88DOCKER_IMAGE_TAG        ?= $(subst /,-,$(shell git rev-parse --abbrev-ref HEAD))
89DOCKERFILE_PATH         ?= ./Dockerfile
90DOCKERBUILD_CONTEXT     ?= ./
91DOCKER_REPO             ?= prom
92
93DOCKER_ARCHS            ?= amd64
94
95BUILD_DOCKER_ARCHS = $(addprefix common-docker-,$(DOCKER_ARCHS))
96PUBLISH_DOCKER_ARCHS = $(addprefix common-docker-publish-,$(DOCKER_ARCHS))
97TAG_DOCKER_ARCHS = $(addprefix common-docker-tag-latest-,$(DOCKER_ARCHS))
98
99ifeq ($(GOHOSTARCH),amd64)
100        ifeq ($(GOHOSTOS),$(filter $(GOHOSTOS),linux freebsd darwin windows))
101                # Only supported on amd64
102                test-flags := -race
103        endif
104endif
105
106# This rule is used to forward a target like "build" to "common-build".  This
107# allows a new "build" target to be defined in a Makefile which includes this
108# one and override "common-build" without override warnings.
109%: common-% ;
110
111.PHONY: common-all
112common-all: precheck style check_license lint unused build test
113
114.PHONY: common-style
115common-style:
116	@echo ">> checking code style"
117	@fmtRes=$$($(GOFMT) -d $$(find . -path ./vendor -prune -o -name '*.go' -print)); \
118	if [ -n "$${fmtRes}" ]; then \
119		echo "gofmt checking failed!"; echo "$${fmtRes}"; echo; \
120		echo "Please ensure you are using $$($(GO) version) for formatting code."; \
121		exit 1; \
122	fi
123
124.PHONY: common-check_license
125common-check_license:
126	@echo ">> checking license header"
127	@licRes=$$(for file in $$(find . -type f -iname '*.go' ! -path './vendor/*') ; do \
128               awk 'NR<=3' $$file | grep -Eq "(Copyright|generated|GENERATED)" || echo $$file; \
129       done); \
130       if [ -n "$${licRes}" ]; then \
131               echo "license header checking failed:"; echo "$${licRes}"; \
132               exit 1; \
133       fi
134
135.PHONY: common-deps
136common-deps:
137	@echo ">> getting dependencies"
138ifdef GO111MODULE
139	GO111MODULE=$(GO111MODULE) $(GO) mod download
140else
141	$(GO) get $(GOOPTS) -t ./...
142endif
143
144.PHONY: common-test-short
145common-test-short:
146	@echo ">> running short tests"
147	GO111MODULE=$(GO111MODULE) $(GO) test -short $(GOOPTS) $(pkgs)
148
149.PHONY: common-test
150common-test:
151	@echo ">> running all tests"
152	GO111MODULE=$(GO111MODULE) $(GO) test $(test-flags) $(GOOPTS) $(pkgs)
153
154.PHONY: common-format
155common-format:
156	@echo ">> formatting code"
157	GO111MODULE=$(GO111MODULE) $(GO) fmt $(pkgs)
158
159.PHONY: common-vet
160common-vet:
161	@echo ">> vetting code"
162	GO111MODULE=$(GO111MODULE) $(GO) vet $(GOOPTS) $(pkgs)
163
164.PHONY: common-lint
165common-lint: $(GOLANGCI_LINT)
166ifdef GOLANGCI_LINT
167	@echo ">> running golangci-lint"
168ifdef GO111MODULE
169# 'go list' needs to be executed before staticcheck to prepopulate the modules cache.
170# Otherwise staticcheck might fail randomly for some reason not yet explained.
171	GO111MODULE=$(GO111MODULE) $(GO) list -e -compiled -test=true -export=false -deps=true -find=false -tags= -- ./... > /dev/null
172	GO111MODULE=$(GO111MODULE) $(GOLANGCI_LINT) run $(GOLANGCI_LINT_OPTS) $(pkgs)
173else
174	$(GOLANGCI_LINT) run $(pkgs)
175endif
176endif
177
178# For backward-compatibility.
179.PHONY: common-staticcheck
180common-staticcheck: lint
181
182.PHONY: common-unused
183common-unused: $(GOVENDOR)
184ifdef GOVENDOR
185	@echo ">> running check for unused packages"
186	@$(GOVENDOR) list +unused | grep . && exit 1 || echo 'No unused packages'
187else
188ifdef GO111MODULE
189	@echo ">> running check for unused/missing packages in go.mod"
190	GO111MODULE=$(GO111MODULE) $(GO) mod tidy
191ifeq (,$(wildcard vendor))
192	@git diff --exit-code -- go.sum go.mod
193else
194	@echo ">> running check for unused packages in vendor/"
195	GO111MODULE=$(GO111MODULE) $(GO) mod vendor
196	@git diff --exit-code -- go.sum go.mod vendor/
197endif
198endif
199endif
200
201.PHONY: common-build
202common-build: promu
203	@echo ">> building binaries"
204	GO111MODULE=$(GO111MODULE) $(PROMU) build --prefix $(PREFIX) $(PROMU_BINARIES)
205
206.PHONY: common-tarball
207common-tarball: promu
208	@echo ">> building release tarball"
209	$(PROMU) tarball --prefix $(PREFIX) $(BIN_DIR)
210
211.PHONY: common-docker $(BUILD_DOCKER_ARCHS)
212common-docker: $(BUILD_DOCKER_ARCHS)
213$(BUILD_DOCKER_ARCHS): common-docker-%:
214	docker build -t "$(DOCKER_REPO)/$(DOCKER_IMAGE_NAME)-linux-$*:$(DOCKER_IMAGE_TAG)" \
215		-f $(DOCKERFILE_PATH) \
216		--build-arg ARCH="$*" \
217		--build-arg OS="linux" \
218		$(DOCKERBUILD_CONTEXT)
219
220.PHONY: common-docker-publish $(PUBLISH_DOCKER_ARCHS)
221common-docker-publish: $(PUBLISH_DOCKER_ARCHS)
222$(PUBLISH_DOCKER_ARCHS): common-docker-publish-%:
223	docker push "$(DOCKER_REPO)/$(DOCKER_IMAGE_NAME)-linux-$*:$(DOCKER_IMAGE_TAG)"
224
225.PHONY: common-docker-tag-latest $(TAG_DOCKER_ARCHS)
226common-docker-tag-latest: $(TAG_DOCKER_ARCHS)
227$(TAG_DOCKER_ARCHS): common-docker-tag-latest-%:
228	docker tag "$(DOCKER_REPO)/$(DOCKER_IMAGE_NAME)-linux-$*:$(DOCKER_IMAGE_TAG)" "$(DOCKER_REPO)/$(DOCKER_IMAGE_NAME)-linux-$*:latest"
229
230.PHONY: common-docker-manifest
231common-docker-manifest:
232	DOCKER_CLI_EXPERIMENTAL=enabled docker manifest create -a "$(DOCKER_REPO)/$(DOCKER_IMAGE_NAME):$(DOCKER_IMAGE_TAG)" $(foreach ARCH,$(DOCKER_ARCHS),$(DOCKER_REPO)/$(DOCKER_IMAGE_NAME)-linux-$(ARCH):$(DOCKER_IMAGE_TAG))
233	DOCKER_CLI_EXPERIMENTAL=enabled docker manifest push "$(DOCKER_REPO)/$(DOCKER_IMAGE_NAME):$(DOCKER_IMAGE_TAG)"
234
235.PHONY: promu
236promu: $(PROMU)
237
238$(PROMU):
239	$(eval PROMU_TMP := $(shell mktemp -d))
240	curl -s -L $(PROMU_URL) | tar -xvzf - -C $(PROMU_TMP)
241	mkdir -p $(FIRST_GOPATH)/bin
242	cp $(PROMU_TMP)/promu-$(PROMU_VERSION).$(GO_BUILD_PLATFORM)/promu $(FIRST_GOPATH)/bin/promu
243	rm -r $(PROMU_TMP)
244
245.PHONY: proto
246proto:
247	@echo ">> generating code from proto files"
248	@./scripts/genproto.sh
249
250ifdef GOLANGCI_LINT
251$(GOLANGCI_LINT):
252	mkdir -p $(FIRST_GOPATH)/bin
253	curl -sfL https://raw.githubusercontent.com/golangci/golangci-lint/$(GOLANGCI_LINT_VERSION)/install.sh \
254		| sed -e '/install -d/d' \
255		| sh -s -- -b $(FIRST_GOPATH)/bin $(GOLANGCI_LINT_VERSION)
256endif
257
258ifdef GOVENDOR
259.PHONY: $(GOVENDOR)
260$(GOVENDOR):
261	GOOS= GOARCH= $(GO) get -u github.com/kardianos/govendor
262endif
263
264.PHONY: precheck
265precheck::
266
267define PRECHECK_COMMAND_template =
268precheck:: $(1)_precheck
269
270PRECHECK_COMMAND_$(1) ?= $(1) $$(strip $$(PRECHECK_OPTIONS_$(1)))
271.PHONY: $(1)_precheck
272$(1)_precheck:
273	@if ! $$(PRECHECK_COMMAND_$(1)) 1>/dev/null 2>&1; then \
274		echo "Execution of '$$(PRECHECK_COMMAND_$(1))' command failed. Is $(1) installed?"; \
275		exit 1; \
276	fi
277endef
278